# required variables
# REGISTRY_USERNAME
# REGISTRY_PASSWORD

variables:
  REGISTRY_SERVER: docker.io
  RELEASE_IMAGE_NAME: tomkukral/tool
  IMAGE_NAME: ${REGISTRY_SERVER}/${RELEASE_IMAGE_NAME}
  IMAGE_NAME_DEV: ${REGISTRY_SERVER}/${RELEASE_IMAGE_NAME}-dev
  IMAGE_RELEASE: ${REGISTRY_SERVER}/${RELEASE_IMAGE_NAME}-dev:${CI_COMMIT_SHORT_SHA}

stages:
  - build
  - test
  - release

.job: &job
  image: docker:latest
  services:
    - docker:dind
  before_script:
    - docker version
    - docker login --username "${REGISTRY_USERNAME}" --password "${REGISTRY_PASSWORD}" "${REGISTRY_SERVER}"
  after_script:
    - docker logout "${REGISTRY_SERVER}"

build:
  <<: *job
  stage: build
  script:
    - docker pull ${IMAGE_RELEASE} || docker build -t "${IMAGE_RELEASE}" --build-arg version=${CI_COMMIT_SHORT_SHA} .
    - docker push "${IMAGE_RELEASE}"

test:
  <<: *job
  image: "${IMAGE_RELEASE}"
  before_script: []
  after_script: []
  script:
  - curl --version
  - certigo --version

release-tag:
  <<: *job
  stage: release
  only:
    - tags
  script:
    - docker pull "${IMAGE_RELEASE}"
    - docker tag "${IMAGE_RELEASE}" "${IMAGE_NAME}:${CI_COMMIT_TAG}"
    - docker push "${IMAGE_NAME}:${CI_COMMIT_TAG}"

release-latest:
  <<: *job
  stage: release
  only:
    - master
  script:
    - docker pull "${IMAGE_RELEASE}"
    - docker tag "${IMAGE_RELEASE}" "${IMAGE_NAME}:latest"
    - docker push "${IMAGE_NAME}:latest"

release-branch:
  <<: *job
  stage: release
  only:
    - branches
  script:
    - docker pull "${IMAGE_RELEASE}"
    - docker tag "${IMAGE_RELEASE}" "${IMAGE_NAME_DEV}:branch-${CI_COMMIT_REF_SLUG}"
    - docker push "${IMAGE_NAME_DEV}:branch-${CI_COMMIT_REF_SLUG}"
